gtkmm: Gtk::Text Class Reference

gtkmm 4.22.0

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gtk::Text Class Reference
Widgets

A simple single-line text entry field. More...

`#include <gtkmm/text.h>`

Inheritance diagram for Gtk::Text:
[legend]

## Public Member Functions
| Text (Text &&src) noexcept
Text & | operator= (Text &&src) noexcept
| Text (const Text &)=delete
Text & | operator= (const Text &)=delete
| ~Text () noexcept override
GtkText * | gobj ()
| Provides access to the underlying C GObject.
const GtkText * | gobj () const
| Provides access to the underlying C GObject.
| Text ()
| Text (const Glib::RefPtr< EntryBuffer > &buffer)
Glib::RefPtr< EntryBuffer > | get_buffer ()
| Get the entry buffer object which holds the text for this widget.
Glib::RefPtr< const EntryBuffer > | get_buffer () const
| Get the entry buffer object which holds the text for this widget.
void | set_buffer (const Glib::RefPtr< EntryBuffer > &buffer)
| Set the entry buffer object which holds the text for this widget.
void | set_visibility (bool visible=true)
| Sets whether the contents of the text widget are visible or not.
bool | get_visibility () const
| Retrieves whether the text is visible.
void | set_invisible_char (gunichar ch)
| Sets the character to use when in “password mode”.
void | unset_invisible_char ()
| Unsets the invisible char.
gunichar | get_invisible_char () const
| Retrieves the character displayed when visibility is set to false.
void | set_overwrite_mode (bool overwrite=true)
| Sets whether the text is overwritten when typing.
bool | get_overwrite_mode () const
| Gets whether text is overwritten when typing.
void | set_max_length (int max)
| Sets the maximum allowed length of the contents.
int | get_max_length () const
| Retrieves the maximum allowed length of the contents.
guint16 | get_text_length () const
| Retrieves the length of the contents.
void | set_activates_default (bool setting=true)
| Sets whether pressing `Enter` will activate the default widget.
bool | get_activates_default () const
| Returns whether pressing `Enter` will activate the default widget for the window containing the widget.
Glib::ustring | get_placeholder_text () const
| Retrieves the text that will be displayed when the text widget is empty and unfocused.
void | set_placeholder_text (const Glib::ustring &text)
| Sets the text to be displayed when the text widget is empty and unfocused.
void | set_input_purpose (InputPurpose purpose)
| Sets the input purpose of the text widget.
InputPurpose | get_input_purpose () const
| Gets the input purpose of the text widget.
void | set_input_hints (InputHints hints)
| Sets hints that allow input methods to fine-tune their behaviour.
InputHints | get_input_hints () const
| Gets the input hints of the text widget.
void | set_attributes (Pango::AttrList &attrs)
| Apply attributes to the contents of the text widget.
Pango::AttrList | get_attributes () const
| Gets the attribute list that was set on the text widget.
void | set_tabs (const Pango::TabArray &tabs)
| Sets tab stops for the text widget.
Pango::TabArray | get_tabs () const
| Gets the tab stops for the text widget.
bool | grab_focus_without_selecting ()
| Causes the text widget to have the keyboard focus.
void | set_extra_menu (const Glib::RefPtr< Gio::MenuModel > &model)
| Sets a menu model to add to the context menu of the text widget.
Glib::RefPtr< Gio::MenuModel > | get_extra_menu ()
| Gets the extra menu model of the text widget.
Glib::RefPtr< const Gio::MenuModel > | get_extra_menu () const
| Gets the extra menu model of the text widget.
void | set_enable_emoji_completion (bool enable_emoji_completion=true)
| Sets whether Emoji completion is enabled.
bool | get_enable_emoji_completion () const
| Returns whether Emoji completion is enabled.
void | set_propagate_text_width (bool propagate_text_width=true)
| Sets whether the text widget should grow and shrink with the content.
bool | get_propagate_text_width () const
| Returns whether the text widget will grow and shrink with the content.
void | set_truncate_multiline (bool truncate_multiline=true)
| Sets whether pasted text should be truncated to the first line.
bool | get_truncate_multiline () const
| Returns whether pasted text will be truncated to the first line.
Glib::SignalProxy< void()> | signal_activate ()
Glib::PropertyProxy< Glib::RefPtr< EntryBuffer > > | property_buffer ()
| The `Gtk::EntryBuffer` object which stores the text.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< EntryBuffer > > | property_buffer () const
| The `Gtk::EntryBuffer` object which stores the text.
Glib::PropertyProxy< int > | property_max_length ()
| Maximum number of characters that are allowed.
Glib::PropertyProxy_ReadOnly< int > | property_max_length () const
| Maximum number of characters that are allowed.
Glib::PropertyProxy< bool > | property_visibility ()
| If false, the text is masked with the “invisible char”.
Glib::PropertyProxy_ReadOnly< bool > | property_visibility () const
| If false, the text is masked with the “invisible char”.
Glib::PropertyProxy< gunichar > | property_invisible_char ()
| The character to used when masking contents (in “password mode”).
Glib::PropertyProxy_ReadOnly< gunichar > | property_invisible_char () const
| The character to used when masking contents (in “password mode”).
Glib::PropertyProxy< bool > | property_invisible_char_set ()
| Whether the invisible char has been set.
Glib::PropertyProxy_ReadOnly< bool > | property_invisible_char_set () const
| Whether the invisible char has been set.
Glib::PropertyProxy< bool > | property_activates_default ()
| Whether to activate the default widget when `Enter` is pressed.
Glib::PropertyProxy_ReadOnly< bool > | property_activates_default () const
| Whether to activate the default widget when `Enter` is pressed.
Glib::PropertyProxy_ReadOnly< int > | property_scroll_offset () const
| Number of pixels scrolled of the screen to the left.
Glib::PropertyProxy< bool > | property_truncate_multiline ()
| When true, pasted multi-line text is truncated to the first line.
Glib::PropertyProxy_ReadOnly< bool > | property_truncate_multiline () const
| When true, pasted multi-line text is truncated to the first line.
Glib::PropertyProxy< bool > | property_overwrite_mode ()
| If text is overwritten when typing.
Glib::PropertyProxy_ReadOnly< bool > | property_overwrite_mode () const
| If text is overwritten when typing.
Glib::PropertyProxy< Glib::ustring > | property_im_module ()
| Which input method module should be used.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_im_module () const
| Which input method module should be used.
Glib::PropertyProxy< Glib::ustring > | property_placeholder_text ()
| The text that will be displayed in the `Gtk::Text` when it is empty and unfocused.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_placeholder_text () const
| The text that will be displayed in the `Gtk::Text` when it is empty and unfocused.
Glib::PropertyProxy< InputPurpose > | property_input_purpose ()
| The purpose of this text field.
Glib::PropertyProxy_ReadOnly< InputPurpose > | property_input_purpose () const
| The purpose of this text field.
Glib::PropertyProxy< InputHints > | property_input_hints ()
| Additional hints that allow input methods to fine-tune their behaviour.
Glib::PropertyProxy_ReadOnly< InputHints > | property_input_hints () const
| Additional hints that allow input methods to fine-tune their behaviour.
Glib::PropertyProxy< Pango::AttrList > | property_attributes ()
| A list of Pango attributes to apply to the text.
Glib::PropertyProxy_ReadOnly< Pango::AttrList > | property_attributes () const
| A list of Pango attributes to apply to the text.
Glib::PropertyProxy< Pango::TabArray > | property_tabs ()
| Custom tabs for this text widget.
Glib::PropertyProxy_ReadOnly< Pango::TabArray > | property_tabs () const
| Custom tabs for this text widget.
Glib::PropertyProxy< bool > | property_enable_emoji_completion ()
| Whether to suggest Emoji replacements.
Glib::PropertyProxy_ReadOnly< bool > | property_enable_emoji_completion () const
| Whether to suggest Emoji replacements.
Glib::PropertyProxy< bool > | property_propagate_text_width ()
| Whether the widget should grow and shrink with the content.
Glib::PropertyProxy_ReadOnly< bool > | property_propagate_text_width () const
| Whether the widget should grow and shrink with the content.
Glib::PropertyProxy< Glib::RefPtr< Gio::MenuModel > > | property_extra_menu ()
| A menu model whose contents will be appended to the context menu.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::MenuModel > > | property_extra_menu () const
| A menu model whose contents will be appended to the context menu.
Public Member Functions inherited from Gtk::Widget
| Widget (Widget &&src) noexcept
Widget & | operator= (Widget &&src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget.
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget.
void | show ()
| Flags a widget to be displayed.
void | hide ()
| Reverses the effects of [method.Gtk.Widget.show].
void | queue_draw ()
| Schedules this widget to be redrawn.
void | queue_resize ()
| Flags a widget to have its size renegotiated.
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function.
void | size_allocate (const Allocation &allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int &minimum_baseline, int &natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size.
Measurements | measure (Orientation orientation, int for_size=-1) const
| Like the other overload of measure() but returns a structure holding the sizes/baselines instead of using output parameters.
void | get_preferred_size (Requisition &minimum_size, Requisition &natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
PreferredSize | get_preferred_size () const
| Like the other overload of get_preferred_size() but returns a structure holding the sizes instead of using output parameters.
void | set_layout_manager (const Glib::RefPtr< LayoutManager > &layout_manager)
| Sets the layout manager to use for measuring and allocating children of the widget.
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager().
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager of the widget.
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager of the widget.
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | set_can_focus (bool can_focus=true)
| Sets whether the input focus can enter the widget or any of its children.
bool | get_can_focus () const
| Determines whether the input focus can enter the widget or any of its children.
void | set_focusable (bool focusable=true)
| Sets whether the widget can own the input focus.
bool | get_focusable () const
| Determines whether the widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
bool | grab_focus ()
| Causes widget to have the keyboard focus for the window that it belongs to.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_target (bool can_target=true)
| Sets whether the widget can be the target of pointer events.
bool | get_can_target () const
| Queries whether the widget can be the target of pointer events.
bool | has_default () const
| Determines whether the widget is the current default widget within its toplevel.
void | set_receives_default (bool receives_default=true)
| Sets whether the widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether the widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
void | set_name (const Glib::ustring & name)
| Sets a widgets name.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state.
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of the widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity.
bool | is_sensitive () const
| Returns the widget’s effective sensitivity.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | is_drawable () const
| Determines whether the widget can be drawn to.
bool | get_realized () const
| Determines whether the widget is realized.
bool | get_mapped () const
| Returns whether the widget is mapped.
void | set_child_visible (bool visible=true)
| Sets whether the widget should be mapped along with its parent.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
int | get_allocated_width () const
| Returns the width that has currently been allocated to the widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to the widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to the widget.
Allocation | get_allocation () const
| Retrieves the widget’s location.
std::optional< Gdk::Graphene::Rect > | compute_bounds (const Widget & target) const
| Computes the bounds for the widget in the coordinate space of target.
std::optional< Gdk::Graphene::Point > | compute_point (const Widget & target, const Gdk::Graphene::Point &point) const
| Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.
int | get_width () const
| Returns the content width of the widget.
int | get_height () const
| Returns the content height of the widget.
int | get_baseline () const
| Returns the baseline that has currently been allocated to the widget.
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget.
Widget * | get_parent ()
| Returns the parent widget of the widget.
const Widget * | get_parent () const
| Returns the parent widget of the widget.
Root * | get_root ()
| Returns the `Gtk::Root` widget of the widget.
const Root * | get_root () const
| Returns the `Gtk::Root` widget of the widget.
Native * | get_native ()
| Returns the nearest `Gtk::Native` ancestor of the widget.
const Native * | get_native () const
| Returns the nearest `Gtk::Native` ancestor of the widget.
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts.
bool | keynav_failed (DirectionType direction)
| Emits the signal_keynav_failed() signal on the widget.
void | error_bell ()
| Notifies the user about an input-related error on the widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of the widget.
void | get_size_request (int & width, int &height) const
| Gets the size request that was explicitly set for the widget.
Requisition | get_size_request () const
| Like the other overload of get_size_request() but returns a structure holding the sizes instead of using output parameters.
void | set_opacity (double opacity)
| Requests the widget to be rendered partially transparent.
double | get_opacity () const
| Fetches the requested opacity for the widget.
void | set_overflow (Overflow overflow)
| Sets how the widget treats content that is drawn outside the it's content area.
Overflow | get_overflow () const
| Returns the widget’s overflow value.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of the widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of the widget with type widget_type.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the display for the window that the widget belongs to.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the display for the window that the widget belongs to.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of the widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether the `hexpand` flag has been explicitly set.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether the `vexpand` flag has been explicitly set.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used.
bool | compute_expand (Orientation orientation)
| Computes whether a parent widget should give this widget extra space when possible.
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions.
Align | get_halign () const
| Gets the horizontal alignment of the widget.
void | set_halign (Align align)
| Sets the horizontal alignment of the widget.
Align | get_valign () const
| Gets the vertical alignment of the widget.
void | set_valign (Align align)
| Sets the vertical alignment of the widget.
int | get_margin_start () const
| Gets the start margin of the widget.
void | set_margin_start (int margin)
| Sets the start margin of the widget.
int | get_margin_end () const
| Gets the end margin of the widget.
void | set_margin_end (int margin)
| Sets the end margin of the widget.
int | get_margin_top () const
| Gets the top margin of the widget.
void | set_margin_top (int margin)
| Sets the top margin of the widget.
int | get_margin_bottom () const
| Gets the bottom margin of the widget.
void | set_margin_bottom (int margin)
| Sets the bottom margin of the widget.
void | set_margin (int margin)
| Set all 4 margins to the same value.
bool | is_ancestor (Widget &ancestor) const
| Determines whether the widget is a descendent of ancestor.
bool | translate_coordinates (Widget &dest_widget, double src_x, double src_y, double &dest_x, double &dest_y)
| Translates coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
bool | contains (double x, double y) const
| Tests if a given point is contained in the widget.
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of the widget closest to a point.
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of the widget closest to a point.
void | add_controller (const Glib::RefPtr< EventController > &controller)
| Adds an event controller to the widget.
void | remove_controller (const Glib::RefPtr< EventController > &controller)
| Removes an event controller from the widget.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new `Pango::Context` that is configured for the widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a `Pango::Context` that is configured for the widget.
void | set_font_options (const Cairo::FontOptions &options)
| Sets the `cairo_font_options_t` used for text rendering in the widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
Cairo::FontOptions | get_font_options () const
| Returns the `cairo_font_options_t` of the widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring &text)
| Creates a new `Pango::Layout` that is configured for the widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on the widget.
TextDirection | get_direction () const
| Gets the reading direction for the widget.
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > &cursor)
| Sets the cursor to be shown when the pointer hovers over the widget.
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget.
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Gets the cursor set on the widget.
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Gets the cursor set on the widget.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic.
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic.
void | add_mnemonic_label (Widget &label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget &label)
| Removes a widget from the list of mnemonic labels for this widget.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
void | set_parent (Widget & parent)
| Sets the parent widget of the widget.
void | unparent ()
| Removes widget from its parent.
void | map ()
| Causes a widget to be mapped if it isn’t already.
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display of the widget.
void | set_tooltip_text (const Glib::ustring &text)
| Sets the contents of the tooltip for the widget.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for the widget.
void | set_tooltip_markup (const Glib::ustring &markup)
| Sets the contents of the tooltip for widget.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for the widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the `has-tooltip` property on the widget.
bool | get_has_tooltip () const
| Returns the current value of the `has-tooltip` property.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to the widget.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to the widget.
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts an action group into the widget's actions.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase &args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it.
void | activate_default ()
| Activates the `default.activate` action for the widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > &font_map)
| Sets the font map to use for text rendering in the widget.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of the widget.
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of the widget.
Widget * | get_first_child ()
| Returns the widget’s first child.
const Widget * | get_first_child () const
| Returns the widget’s first child.
Widget * | get_last_child ()
| Returns the widget’s last child.
const Widget * | get_last_child () const
| Returns the widget’s last child.
Widget * | get_next_sibling ()
| Returns the widget’s next sibling.
const Widget * | get_next_sibling () const
| Returns the widget’s next sibling.
Widget * | get_prev_sibling ()
| Returns the widget’s previous sibling.
const Widget * | get_prev_sibling () const
| Returns the widget’s previous sibling.
std::vector< Widget * > | get_children ()
| Gets a vector of the widgetʼs current children, from first child to last.
std::vector< const Widget * > | get_children () const
| Gets a vector of the widgetʼs current children, from first child to last.
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a list model to track the children of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a list model to track the children of the widget.
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a list model to track the event controllers of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a list model to track the event controllers of the widget.
void | insert_after (Widget & parent, const Widget &previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling.
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling.
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent.
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent.
void | snapshot_child (Widget &child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshots a child of the widget.
bool | should_layout () const
| Returns whether the widget should contribute to the measuring and allocation of its parent.
Glib::ustring | get_css_name () const
| Returns the CSS name of the widget.
void | add_css_class (const Glib::ustring &css_class)
| Adds a style class to the widget.
void | remove_css_class (const Glib::ustring &css_class)
| Removes a style from the widget.
bool | has_css_class (const Glib::ustring &css_class) const
| Returns whether a style class is currently applied to the widget.
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to the widget.
void | set_css_classes (const std::vector< Glib::ustring > &classes)
| Replaces the current style classes of the widget with classes.
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style.
void | set_limit_events (bool limit_events=true)
| Sets whether the widget acts like a modal dialog, with respect to event delivery.
bool | get_limit_events () const
| Gets the value of the property_limit_events() property.
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase.
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The `Gtk::Root` widget of the widget tree containing this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Overrides for width request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Overrides for width request of the widget.
Glib::PropertyProxy< int > | property_height_request ()
| Overrides for height request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Overrides for height request of the widget.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events.
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the `hexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the `hexpand` property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the `vexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the `vexpand` property.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree.
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget.
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy< bool > | property_limit_events ()
| Makes this widget act like a modal dialog, with respect to event delivery.
Glib::PropertyProxy_ReadOnly< bool > | property_limit_events () const
| Makes this widget act like a modal dialog, with respect to event delivery.
Public Member Functions inherited from Gtk::Object
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible &&src) noexcept
Accessible & | operator= (Accessible &&src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject.
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the implementation for the given accessible object.
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the implementation for the given accessible object.
bool | get_platform_state (PlatformState state) const
| Queries a platform state, such as focus.
void | update_platform_state (PlatformState state)
| Informs ATs that the platform state has changed.
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object.
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object.
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > & next_sibling)
| Sets the parent and sibling of an accessible object.
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object.
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object.
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > &new_sibling)
| Updates the next accessible sibling.
bool | get_bounds (int &x, int &y, int & width, int &height) const
| Queries the coordinates and dimensions of this accessible.
Glib::ustring | get_accessible_id () const
| Retrieves the accessible identifier for the accessible object.
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object.
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state.
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property.
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation.
void | reset_state (State state)
| Resets the accessible state to its default value.
void | reset_property (Property property)
| Resets the accessible property to its default value.
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value.
void | announce (const Glib::ustring & message, AnnouncementPriority priority)
| Requests the user's screen reader to announce the given message.
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given `Gtk::Accessible` implementation.
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given `Gtk::Accessible` implementation.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable &&src) noexcept
Buildable & | operator= (Buildable &&src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget &&src) noexcept
ConstraintTarget & | operator= (ConstraintTarget &&src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject.
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Gtk::Editable
| Editable (Editable &&src) noexcept
Editable & | operator= (Editable &&src) noexcept
| ~Editable () noexcept override
GtkEditable * | gobj ()
| Provides access to the underlying C GObject.
const GtkEditable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_text () const
| Retrieves the contents of editable.
void | set_text (const Glib::ustring &text)
| Sets the text in the editable to the given value.
void | delete_selection ()
| Deletes the currently selected text of the editable.
void | set_editable (bool is_editable=true)
| Determines if the user can edit the text in the editable widget.
bool | get_editable () const
| Retrieves whether editable is editable.
void | insert_text (const Glib::ustring &new_text, int new_text_length, int & position)
| Inserts new_text_length bytes of new_text into the contents of the widget, at position position.
void | delete_text (int start_pos, int end_pos)
| Deletes a sequence of characters.
Glib::ustring | get_chars (int start_pos, int end_pos) const
| Retrieves a sequence of characters.
void | select_region (int start_pos, int end_pos)
| Selects a region of text.
bool | get_selection_bounds (int &start_pos, int &end_pos) const
| Retrieves the selection bound of the editable.
void | set_position (int position)
| Sets the cursor position in the editable to the given value.
int | get_position () const
| Retrieves the current position of the cursor relative to the start of the content of the editable.
float | get_alignment () const
| Gets the alignment of the editable.
void | set_alignment (float xalign)
| Sets the alignment for the contents of the editable.
int | get_width_chars () const
| Gets the number of characters of space reserved for the contents of the editable.
void | set_width_chars (int n_chars)
| Changes the size request of the editable to be about the right size for n_chars characters.
int | get_max_width_chars () const
| Retrieves the desired maximum width of editable, in characters.
void | set_max_width_chars (int n_chars)
| Sets the desired maximum width in characters of editable.
bool | get_enable_undo () const
| Gets if undo/redo actions are enabled for editable.
void | set_enable_undo (bool enable_undo=true)
| If enabled, changes to editable will be saved for undo/redo actions.
Glib::SignalProxy< void(const Glib::ustring &, int *)> | signal_insert_text ()
Glib::SignalProxy< void(int, int)> | signal_delete_text ()
Glib::SignalProxy< void()> | signal_changed ()
Glib::PropertyProxy< Glib::ustring > | property_text ()
| The contents of the entry.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_text () const
| The contents of the entry.
Glib::PropertyProxy_ReadOnly< int > | property_cursor_position () const
| The current position of the insertion cursor in chars.
Glib::PropertyProxy< bool > | property_enable_undo ()
| If undo/redo should be enabled for the editable.
Glib::PropertyProxy_ReadOnly< bool > | property_enable_undo () const
| If undo/redo should be enabled for the editable.
Glib::PropertyProxy_ReadOnly< int > | property_selection_bound () const
| The position of the opposite end of the selection from the cursor in chars.
Glib::PropertyProxy< bool > | property_editable ()
| Whether the entry contents can be edited.
Glib::PropertyProxy_ReadOnly< bool > | property_editable () const
| Whether the entry contents can be edited.
Glib::PropertyProxy< int > | property_width_chars ()
| Number of characters to leave space for in the entry.
Glib::PropertyProxy_ReadOnly< int > | property_width_chars () const
| Number of characters to leave space for in the entry.
Glib::PropertyProxy< int > | property_max_width_chars ()
| The desired maximum width of the entry, in characters.
Glib::PropertyProxy_ReadOnly< int > | property_max_width_chars () const
| The desired maximum width of the entry, in characters.
Glib::PropertyProxy< float > | property_xalign ()
| The horizontal alignment, from 0 (left) to 1 (right).
Glib::PropertyProxy_ReadOnly< float > | property_xalign () const
| The horizontal alignment, from 0 (left) to 1 (right).

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets.
static TextDirection | get_default_direction ()
| Obtains the default reading direction.
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Editable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Gtk::Text * | wrap (GtkText *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Editable
Glib::RefPtr< Gtk::Editable > | wrap (GtkEditable *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Gtk::Widget
using | PreferredSize = MinimumNatural< Requisition >
| Structure returned by the non-output-parameter overload of get_preferred_size().
using | SlotTick = sigc::slot< bool(const Glib::RefPtr< Gdk::FrameClock > &)>
| Callback type for adding a function to update animations.
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::Accessible
enum class | Role { Role::ALERT , Role::ALERT_DIALOG , Role::BANNER , Role::BUTTON , Role::CAPTION , Role::CELL , Role::CHECKBOX , Role::COLUMN_HEADER , Role::COMBO_BOX , Role::COMMAND , Role::COMPOSITE , Role::DIALOG , Role::DOCUMENT , Role::FEED , Role::FORM , Role::GENERIC , Role::GRID , Role::GRID_CELL , Role::GROUP , Role::HEADING , Role::IMG , Role::INPUT , Role::LABEL , Role::LANDMARK , Role::LEGEND , Role::LINK , Role::LIST , Role::LIST_BOX , Role::LIST_ITEM , Role::LOG , Role::MAIN , Role::MARQUEE , Role::MATH , Role::METER , Role::MENU , Role::MENU_BAR , Role::MENU_ITEM , Role::MENU_ITEM_CHECKBOX , Role::MENU_ITEM_RADIO , Role::NAVIGATION , Role::NONE , Role::NOTE , Role::OPTION , Role::PRESENTATION , Role::PROGRESS_BAR , Role::RADIO , Role::RADIO_GROUP , Role::RANGE , Role::REGION , Role::ROW , Role::ROW_GROUP , Role::ROW_HEADER , Role::SCROLLBAR , Role::SEARCH , Role::SEARCH_BOX , Role::SECTION , Role::SECTION_HEAD , Role::SELECT , Role::SEPARATOR , Role::SLIDER , Role::SPIN_BUTTON , Role::STATUS , Role::STRUCTURE , Role::SWITCH , Role::TAB , Role::TABLE , Role::TAB_LIST , Role::TAB_PANEL , Role::TEXT_BOX , Role::TIME , Role::TIMER , Role::TOOLBAR , Role::TOOLTIP , Role::TREE , Role::TREE_GRID , Role::TREE_ITEM , Role::WIDGET , Role::WINDOW , Role::TOGGLE_BUTTON , Role::APPLICATION , Role::PARAGRAPH , Role::BLOCK_QUOTE , Role::ARTICLE , Role::COMMENT , Role::TERMINAL }
| The accessible role for a Gtk::Accessible implementation. More...
enum class | State { State::BUSY , State::CHECKED , State::DISABLED , State::EXPANDED , State::HIDDEN , State::INVALID , State::PRESSED , State::SELECTED , State::VISITED }
| The possible accessible states of a Gtk::Accessible. More...
enum class | Property { Property::AUTOCOMPLETE , Property::DESCRIPTION , Property::HAS_POPUP , Property::KEY_SHORTCUTS , Property::LABEL , Property::LEVEL , Property::MODAL , Property::MULTI_LINE , Property::MULTI_SELECTABLE , Property::ORIENTATION , Property::PLACEHOLDER , Property::READ_ONLY , Property::REQUIRED , Property::ROLE_DESCRIPTION , Property::SORT , Property::VALUE_MAX , Property::VALUE_MIN , Property::VALUE_NOW , Property::VALUE_TEXT , Property::HELP_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum class | Relation { Relation::ACTIVE_DESCENDANT , Relation::COL_COUNT , Relation::COL_INDEX , Relation::COL_INDEX_TEXT , Relation::COL_SPAN , Relation::CONTROLS , Relation::DESCRIBED_BY , Relation::DETAILS , Relation::ERROR_MESSAGE , Relation::FLOW_TO , Relation::LABELLED_BY , Relation::OWNS , Relation::POS_IN_SET , Relation::ROW_COUNT , Relation::ROW_INDEX , Relation::ROW_INDEX_TEXT , Relation::ROW_SPAN , Relation::SET_SIZE , Relation::LABEL_FOR , Relation::DESCRIPTION_FOR , Relation::CONTROLLED_BY , Relation::DETAILS_FOR , Relation::ERROR_MESSAGE_FOR , Relation::FLOW_FROM }
| The possible accessible relations of a Gtk::Accessible. More...
enum class | PlatformState { PlatformState::FOCUSABLE , PlatformState::FOCUSED , PlatformState::ACTIVE }
| The various platform states which can be queried using Gtk::Accessible::get_platform_state(). More...
enum class | AnnouncementPriority { AnnouncementPriority::LOW , AnnouncementPriority::MEDIUM , AnnouncementPriority::HIGH }
| The priority of an accessibility announcement. More...
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int &minimum_baseline, int &natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget *child)
| Sets the focused child of widget.
virtual void | compute_expand_vfunc (bool &hexpand_p, bool &vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget.
void | unrealize ()
| Causes a widget to be unrealized.
void | realize_if_needed ()
void | set_focus_child (Widget &child)
| Set the focus child of the widget.
void | unset_focus_child ()
| Unsets the focus child of the widget.
Widget * | get_focus_child ()
| Returns the focus child of the widget.
const Widget * | get_focus_child () const
| Returns the focus child of the widget.
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > &tooltip)
| This is a default handler for the signal signal_query_tooltip().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Editable
| Editable ()
| You should derive from this class to use it.
virtual void | delete_text_vfunc (int start_pos, int end_pos)
virtual Glib::ustring | get_text_vfunc () const
virtual void | select_region_vfunc (int start_pos, int end_pos)
virtual bool | get_selection_bounds_vfunc (int &start_pos, int &end_pos) const
virtual void | insert_text_vfunc (const Glib::ustring &text, int & position)
virtual void | on_insert_text (const Glib::ustring &text, int * position)
| This is a default handler for the signal signal_insert_text().
virtual void | on_delete_text (int start_pos, int end_pos)
| This is a default handler for the signal signal_delete_text().
virtual void | on_changed ()
| This is a default handler for the signal signal_changed().

## Detailed Description

A simple single-line text entry field.

The Gtk::Text widget is a single-line text entry widget. A fairly large set of key bindings are supported by default. If the entered text is longer than the allocation of the widget, the widget will scroll so that the cursor position is visible.

When using an entry for passwords and other sensitive information, it can be put into “password mode” using set_visibility(). In this mode, entered text is displayed using an “invisible” character. By default, GTK picks the best invisible character that is available in the current font, but it can be changed with set_invisible_char().

If you are looking to add icons or progress display in an entry, look at Gtk::Entry. There are other alternatives for more specialized use cases, such as Gtk::SearchEntry. If you need multi-line editable text, look at Gtk::TextView.

See also
  Entry, TextView

Since gtkmm 3.96:

## Constructor & Destructor Documentation

## ◆ Text() [1/4]

Gtk::Text::Text | ( | Text && | src | ) |
| noexcept

## ◆ Text() [2/4]

Gtk::Text::Text | ( | const Text & |  | ) |
| delete

## ◆ ~Text()

Gtk::Text::~Text | ( |  | ) |
| overridenoexcept

## ◆ Text() [3/4]

Gtk::Text::Text | ( |  | ) |

## ◆ Text() [4/4]

Gtk::Text::Text | ( | const Glib::RefPtr< EntryBuffer > & | buffer | ) |
| explicit

## Member Function Documentation

## ◆ get_activates_default()

bool Gtk::Text::get_activates_default | ( |  | ) | const

Returns whether pressing `Enter` will activate the default widget for the window containing the widget.

See set_activates_default().

Returns
  True if self will activate the default widget.

## ◆ get_attributes()

Pango::AttrList Gtk::Text::get_attributes | ( |  | ) | const

Gets the attribute list that was set on the text widget.

See set_attributes().

Returns
  The attribute list.

## ◆ get_buffer() [1/2]

Glib::RefPtr< EntryBuffer > Gtk::Text::get_buffer | ( |  | ) |

Get the entry buffer object which holds the text for this widget.

Returns
  The entry buffer object.

## ◆ get_buffer() [2/2]

Glib::RefPtr< const EntryBuffer > Gtk::Text::get_buffer | ( |  | ) | const

Get the entry buffer object which holds the text for this widget.

Returns
  The entry buffer object.

## ◆ get_enable_emoji_completion()

bool Gtk::Text::get_enable_emoji_completion | ( |  | ) | const

Returns whether Emoji completion is enabled.

Returns
  True if Emoji completion is enabled.

## ◆ get_extra_menu() [1/2]

Glib::RefPtr< Gio::MenuModel > Gtk::Text::get_extra_menu | ( |  | ) |

Gets the extra menu model of the text widget.

See set_extra_menu().

Returns
  The menu model.

## ◆ get_extra_menu() [2/2]

Glib::RefPtr< const Gio::MenuModel > Gtk::Text::get_extra_menu | ( |  | ) | const

Gets the extra menu model of the text widget.

See set_extra_menu().

Returns
  The menu model.

## ◆ get_input_hints()

InputHints Gtk::Text::get_input_hints | ( |  | ) | const

Gets the input hints of the text widget.

Returns
  The input hints.

## ◆ get_input_purpose()

InputPurpose Gtk::Text::get_input_purpose | ( |  | ) | const

Gets the input purpose of the text widget.

Returns
  The input purpose.

## ◆ get_invisible_char()

gunichar Gtk::Text::get_invisible_char | ( |  | ) | const

Retrieves the character displayed when visibility is set to false.

Note that GTK does not compute this value unless it needs it, so the value returned by this function is not very useful unless it has been explicitly set with set_invisible_char().

Returns
  The current invisible char, or 0, if text does not show invisible text at all.

## ◆ get_max_length()

int Gtk::Text::get_max_length | ( |  | ) | const

Retrieves the maximum allowed length of the contents.

See set_max_length().

This is equivalent to getting self's `Gtk::EntryBuffer` and calling Gtk::EntryBuffer::get_max_length() on it.

Returns
  The maximum allowed number of characters, or 0 if there is no limit.

## ◆ get_overwrite_mode()

bool Gtk::Text::get_overwrite_mode | ( |  | ) | const

Gets whether text is overwritten when typing.

See set_overwrite_mode().

Returns
  Whether text is overwritten when typing.

## ◆ get_placeholder_text()

Glib::ustring Gtk::Text::get_placeholder_text | ( |  | ) | const

Retrieves the text that will be displayed when the text widget is empty and unfocused.

See set_placeholder_text().

Returns
  The placeholder text.

## ◆ get_propagate_text_width()

bool Gtk::Text::get_propagate_text_width | ( |  | ) | const

Returns whether the text widget will grow and shrink with the content.

Returns
  True if self will propagate the text width.

## ◆ get_tabs()

Pango::TabArray Gtk::Text::get_tabs | ( |  | ) | const

Gets the tab stops for the text widget.

See set_tabs().

Returns
  The tab stops.

## ◆ get_text_length()

guint16 Gtk::Text::get_text_length | ( |  | ) | const

Retrieves the length of the contents.

This is equivalent to getting self's `Gtk::EntryBuffer` and calling Gtk::EntryBuffer::get_length() on it.

Returns
  The length of the contents, in characters.

## ◆ get_truncate_multiline()

bool Gtk::Text::get_truncate_multiline | ( |  | ) | const

Returns whether pasted text will be truncated to the first line.

Returns
  True if self will truncate pasted multi-line text.

## ◆ get_type()

static GType Gtk::Text::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_visibility()

bool Gtk::Text::get_visibility | ( |  | ) | const

Retrieves whether the text is visible.

Returns
  True if the text is visible.

## ◆ gobj() [1/2]

GtkText * Gtk::Text::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkText * Gtk::Text::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ grab_focus_without_selecting()

bool Gtk::Text::grab_focus_without_selecting | ( |  | ) |

Causes the text widget to have the keyboard focus.

It behaves like Gtk::Widget::grab_focus(), except that it does not select the contents of self.

You only want to call this on some special entries which the user usually doesn't want to replace all text in, such as search-as-you-type entries.

Returns
  True if focus is now inside self.

## ◆ operator=() [1/2]

Text & Gtk::Text::operator= | ( | const Text & |  | ) |
| delete

## ◆ operator=() [2/2]

Text & Gtk::Text::operator= | ( | Text && | src | ) |
| noexcept

## ◆ property_activates_default() [1/2]

Glib::PropertyProxy< bool > Gtk::Text::property_activates_default | ( |  | ) |

Whether to activate the default widget when `Enter` is pressed.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_activates_default() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Text::property_activates_default | ( |  | ) | const

Whether to activate the default widget when `Enter` is pressed.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_attributes() [1/2]

Glib::PropertyProxy< Pango::AttrList > Gtk::Text::property_attributes | ( |  | ) |

A list of Pango attributes to apply to the text.

This is mainly useful to change the size or weight of the text.

The `Pango::Attribute`'s start_index and end_index must refer to the `Gtk::EntryBuffer` text, i.e. without the preedit string.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_attributes() [2/2]

Glib::PropertyProxy_ReadOnly< Pango::AttrList > Gtk::Text::property_attributes | ( |  | ) | const

A list of Pango attributes to apply to the text.

This is mainly useful to change the size or weight of the text.

The `Pango::Attribute`'s start_index and end_index must refer to the `Gtk::EntryBuffer` text, i.e. without the preedit string.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_buffer() [1/2]

Glib::PropertyProxy< Glib::RefPtr< EntryBuffer > > Gtk::Text::property_buffer | ( |  | ) |

The `Gtk::EntryBuffer` object which stores the text.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_buffer() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< EntryBuffer > > Gtk::Text::property_buffer | ( |  | ) | const

The `Gtk::EntryBuffer` object which stores the text.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_enable_emoji_completion() [1/2]

Glib::PropertyProxy< bool > Gtk::Text::property_enable_emoji_completion | ( |  | ) |

Whether to suggest Emoji replacements.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_enable_emoji_completion() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Text::property_enable_emoji_completion | ( |  | ) | const

Whether to suggest Emoji replacements.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_extra_menu() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Gio::MenuModel > > Gtk::Text::property_extra_menu | ( |  | ) |

A menu model whose contents will be appended to the context menu.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_extra_menu() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::MenuModel > > Gtk::Text::property_extra_menu | ( |  | ) | const

A menu model whose contents will be appended to the context menu.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_im_module() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Text::property_im_module | ( |  | ) |

Which input method module should be used.

See Gtk::IMMulticontext.

Setting this to a non-`nullptr` value overrides the system-wide input method. See the Gtk::Settings::property_gtk_im_module() setting.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_im_module() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Text::property_im_module | ( |  | ) | const

Which input method module should be used.

See Gtk::IMMulticontext.

Setting this to a non-`nullptr` value overrides the system-wide input method. See the Gtk::Settings::property_gtk_im_module() setting.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_input_hints() [1/2]

Glib::PropertyProxy< InputHints > Gtk::Text::property_input_hints | ( |  | ) |

Additional hints that allow input methods to fine-tune their behaviour.

Default value: Gtk::InputHints::NONE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_input_hints() [2/2]

Glib::PropertyProxy_ReadOnly< InputHints > Gtk::Text::property_input_hints | ( |  | ) | const

Additional hints that allow input methods to fine-tune their behaviour.

Default value: Gtk::InputHints::NONE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_input_purpose() [1/2]

Glib::PropertyProxy< InputPurpose > Gtk::Text::property_input_purpose | ( |  | ) |

The purpose of this text field.

This information can be used by on-screen keyboards and other input methods to adjust their behaviour.

Note that setting the purpose to [enum@.nosp@m.Gtk..nosp@m.Input.nosp@m.Purp.nosp@m.ose.p.nosp@m.assw.nosp@m.ord] or [enum@.nosp@m.Gtk..nosp@m.Input.nosp@m.Purp.nosp@m.ose.p.nosp@m.in] is independent from setting property_visibility().

Default value: Gtk::InputPurpose::FREE_FORM

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_input_purpose() [2/2]

Glib::PropertyProxy_ReadOnly< InputPurpose > Gtk::Text::property_input_purpose | ( |  | ) | const

The purpose of this text field.

This information can be used by on-screen keyboards and other input methods to adjust their behaviour.

Note that setting the purpose to [enum@.nosp@m.Gtk..nosp@m.Input.nosp@m.Purp.nosp@m.ose.p.nosp@m.assw.nosp@m.ord] or [enum@.nosp@m.Gtk..nosp@m.Input.nosp@m.Purp.nosp@m.ose.p.nosp@m.in] is independent from setting property_visibility().

Default value: Gtk::InputPurpose::FREE_FORM

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_invisible_char() [1/2]

Glib::PropertyProxy< gunichar > Gtk::Text::property_invisible_char | ( |  | ) |

The character to used when masking contents (in “password mode”).

Default value: 42

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_invisible_char() [2/2]

Glib::PropertyProxy_ReadOnly< gunichar > Gtk::Text::property_invisible_char | ( |  | ) | const

The character to used when masking contents (in “password mode”).

Default value: 42

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_invisible_char_set() [1/2]

Glib::PropertyProxy< bool > Gtk::Text::property_invisible_char_set | ( |  | ) |

Whether the invisible char has been set.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_invisible_char_set() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Text::property_invisible_char_set | ( |  | ) | const

Whether the invisible char has been set.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_length() [1/2]

Glib::PropertyProxy< int > Gtk::Text::property_max_length | ( |  | ) |

Maximum number of characters that are allowed.

Zero indicates no limit.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_length() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Text::property_max_length | ( |  | ) | const

Maximum number of characters that are allowed.

Zero indicates no limit.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_overwrite_mode() [1/2]

Glib::PropertyProxy< bool > Gtk::Text::property_overwrite_mode | ( |  | ) |

If text is overwritten when typing.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_overwrite_mode() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Text::property_overwrite_mode | ( |  | ) | const

If text is overwritten when typing.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_placeholder_text() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Text::property_placeholder_text | ( |  | ) |

The text that will be displayed in the `Gtk::Text` when it is empty and unfocused.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_placeholder_text() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Text::property_placeholder_text | ( |  | ) | const

The text that will be displayed in the `Gtk::Text` when it is empty and unfocused.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagate_text_width() [1/2]

Glib::PropertyProxy< bool > Gtk::Text::property_propagate_text_width | ( |  | ) |

Whether the widget should grow and shrink with the content.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagate_text_width() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Text::property_propagate_text_width | ( |  | ) | const

Whether the widget should grow and shrink with the content.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_scroll_offset()

Glib::PropertyProxy_ReadOnly< int > Gtk::Text::property_scroll_offset | ( |  | ) | const

Number of pixels scrolled of the screen to the left.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_tabs() [1/2]

Glib::PropertyProxy< Pango::TabArray > Gtk::Text::property_tabs | ( |  | ) |

Custom tabs for this text widget.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_tabs() [2/2]

Glib::PropertyProxy_ReadOnly< Pango::TabArray > Gtk::Text::property_tabs | ( |  | ) | const

Custom tabs for this text widget.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_truncate_multiline() [1/2]

Glib::PropertyProxy< bool > Gtk::Text::property_truncate_multiline | ( |  | ) |

When true, pasted multi-line text is truncated to the first line.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_truncate_multiline() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Text::property_truncate_multiline | ( |  | ) | const

When true, pasted multi-line text is truncated to the first line.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_visibility() [1/2]

Glib::PropertyProxy< bool > Gtk::Text::property_visibility | ( |  | ) |

If false, the text is masked with the “invisible char”.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_visibility() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Text::property_visibility | ( |  | ) | const

If false, the text is masked with the “invisible char”.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_activates_default()

void Gtk::Text::set_activates_default | ( | bool | setting = `true` | ) |

Sets whether pressing `Enter` will activate the default widget.

This usually means that the dialog containing self will be closed, since the default widget is usually one of the dialog buttons.

Parameters

  setting | True to activate window’s default widget on `Enter` keypress.

## ◆ set_attributes()

void Gtk::Text::set_attributes | ( | Pango::AttrList & | attrs | ) |

Apply attributes to the contents of the text widget.

Parameters

  attrs | A list of style attributes.

## ◆ set_buffer()

void Gtk::Text::set_buffer | ( | const Glib::RefPtr< EntryBuffer > & | buffer | ) |

Set the entry buffer object which holds the text for this widget.

Parameters

  buffer | An entry buffer object.

## ◆ set_enable_emoji_completion()

void Gtk::Text::set_enable_emoji_completion | ( | bool | enable_emoji_completion = `true` | ) |

Sets whether Emoji completion is enabled.

If it is, typing ':', followed by a recognized keyword, will pop up a window with suggested Emojis matching the keyword.

Parameters

  enable_emoji_completion | True to enable Emoji completion.

## ◆ set_extra_menu()

void Gtk::Text::set_extra_menu | ( | const Glib::RefPtr< Gio::MenuModel > & | model | ) |

Sets a menu model to add to the context menu of the text widget.

Parameters

  model | A menu model.

## ◆ set_input_hints()

void Gtk::Text::set_input_hints | ( | InputHints | hints | ) |

Sets hints that allow input methods to fine-tune their behaviour.

Parameters

  hints | Input hints.

## ◆ set_input_purpose()

void Gtk::Text::set_input_purpose | ( | InputPurpose | purpose | ) |

Sets the input purpose of the text widget.

The input purpose can be used by on-screen keyboards and other input methods to adjust their behaviour.

Parameters

  purpose | The input purpose.

## ◆ set_invisible_char()

void Gtk::Text::set_invisible_char | ( | gunichar | ch | ) |

Sets the character to use when in “password mode”.

By default, GTK picks the best invisible char available in the current font. If you set the invisible char to 0, then the user will get no feedback at all; there will be no text on the screen as they type.

Parameters

  ch | A Unicode character.

## ◆ set_max_length()

void Gtk::Text::set_max_length | ( | int | max | ) |

Sets the maximum allowed length of the contents.

If the current contents are longer than the given length, they will be truncated to fit.

This is equivalent to getting self's `Gtk::EntryBuffer` and calling Gtk::EntryBuffer::set_max_length() on it.

Parameters

  max | The maximum length of the text, or 0 for no maximum. (other than the maximum length of entries.) The value passed in will be clamped to the range 0-65536.

## ◆ set_overwrite_mode()

void Gtk::Text::set_overwrite_mode | ( | bool | overwrite = `true` | ) |

Sets whether the text is overwritten when typing.

Parameters

  overwrite | New value.

## ◆ set_placeholder_text()

void Gtk::Text::set_placeholder_text | ( | const Glib::ustring & | text | ) |

Sets the text to be displayed when the text widget is empty and unfocused.

This can be used to give a visual hint of the expected contents of the text widget.

Parameters

  text | A string to be displayed when self is empty and unfocused.

## ◆ set_propagate_text_width()

void Gtk::Text::set_propagate_text_width | ( | bool | propagate_text_width = `true` | ) |

Sets whether the text widget should grow and shrink with the content.

Parameters

  propagate_text_width | True to propagate the text width.

## ◆ set_tabs()

void Gtk::Text::set_tabs | ( | const Pango::TabArray & | tabs | ) |

Sets tab stops for the text widget.

Parameters

  tabs | Tab stops.

## ◆ set_truncate_multiline()

void Gtk::Text::set_truncate_multiline | ( | bool | truncate_multiline = `true` | ) |

Sets whether pasted text should be truncated to the first line.

Parameters

  truncate_multiline | True to truncate multi-line text.

## ◆ set_visibility()

void Gtk::Text::set_visibility | ( | bool | visible = `true` | ) |

Sets whether the contents of the text widget are visible or not.

When visibility is set to false, characters are displayed as the invisible char, and it will also appear that way when the text in the widget is copied to the clipboard.

By default, GTK picks the best invisible character available in the current font, but it can be changed with set_invisible_char().

Note that you probably want to set property_input_purpose() to [enum@.nosp@m.Gtk..nosp@m.Input.nosp@m.Purp.nosp@m.ose.p.nosp@m.assw.nosp@m.ord] or [enum@.nosp@m.Gtk..nosp@m.Input.nosp@m.Purp.nosp@m.ose.p.nosp@m.in] to inform input methods about the purpose of this widget, in addition to setting visibility to false.

Parameters

  visible | True if the contents of the text widget are displayed as plain text.

## ◆ signal_activate()

Glib::SignalProxy< void()> Gtk::Text::signal_activate | ( |  | ) |

Slot Prototype:
  `void on_my_activate()`

Flags: Run Last, Action

Emitted when the user hits the `Enter` key.

The default bindings for this signal are all forms of the `Enter` key.

Since gtkmm 4.18:

## ◆ unset_invisible_char()

void Gtk::Text::unset_invisible_char | ( |  | ) |

Unsets the invisible char.

After calling this, the default invisible char is used again.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::Text * wrap | ( | GtkText * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.